package RedCorona.LongTasks {
	/**
	* This task loops through a list of items, running a function on one
	* item each time it is called.
	*/
	public class LoopTask implements ITask {
		private var list:Vector.<*>;
		private var index:int = 0;
		private var f:Function;
		private var _source:*;
		
		public function LoopTask(list:Vector.<*>, f:Function, source:* ) {
			this.list = list;
			this.f = f;
			this._source = source;
		}		
		
		public function get complete() : Boolean { return index >= list.length; }
		public function get progress() : Number { return index; }
		public function get total() : Number { return list.length; }
		public function get source() : * { return source; }
		public function doNextItem() : void {
			if (!complete) {
				f(list[index++]);
			}
		}
	}
}