package RedCorona.LongTasks {
	/**
	* This task repeats the same function a given number of times.
	*/
	public class RepeatTask implements ITask {
		private var max:int;
		private var index:int = 0;
		private var f:Function;
		private var _source:*;
		
		public function RepeatTask(max:int, f:Function, source:* ) {
			this.max = max;
			this.f = f;
			this._source = source;
		}		
		
		public function get complete() : Boolean { return index >= max; }
		public function get progress() : Number { return index; }
		public function get total() : Number { return max; }
		public function get source() : * { return source; }
		public function doNextItem() : void {
			if (!complete) {
				f(index++);
			}
		}
	}
}